package sun.awt.windows;

import java.net.URI;
import java.io.IOException;
import java.io.File;
import java.awt.Desktop;
import java.awt.peer.DesktopPeer;

final class WDesktopPeer implements DesktopPeer
{
    private static String ACTION_OPEN_VERB;
    private static String ACTION_EDIT_VERB;
    private static String ACTION_PRINT_VERB;
    
    WDesktopPeer() {
    }
    
    @Override
    public boolean isSupported(Desktop.Action action) {
        return true;
    }
    
    @Override
    public void open(File file) throws IOException {
        this.ShellExecute(file, WDesktopPeer.ACTION_OPEN_VERB);
    }
    
    @Override
    public void edit(File file) throws IOException {
        this.ShellExecute(file, WDesktopPeer.ACTION_EDIT_VERB);
    }
    
    @Override
    public void print(File file) throws IOException {
        this.ShellExecute(file, WDesktopPeer.ACTION_PRINT_VERB);
    }
    
    @Override
    public void mail(URI uri) throws IOException {
        this.ShellExecute(uri, WDesktopPeer.ACTION_OPEN_VERB);
    }
    
    @Override
    public void browse(URI uri) throws IOException {
        this.ShellExecute(uri, WDesktopPeer.ACTION_OPEN_VERB);
    }
    
    private void ShellExecute(File obj, String str) throws IOException {
        String shellExecute = ShellExecute(obj.getAbsolutePath(), str);
        if (shellExecute != null) {
            throw new IOException("Failed to " + str + " " + obj + ". Error message: " + shellExecute);
        }
        return;
    }
    
    private void ShellExecute(URI obj, String str) throws IOException {
        String shellExecute = ShellExecute(obj.toString(), str);
        if (shellExecute != null) {
            throw new IOException("Failed to " + str + " " + obj + ". Error message: " + shellExecute);
        }
        return;
    }
    
    private static native String ShellExecute(String p0, String p1);
    
    static {
        WDesktopPeer.ACTION_OPEN_VERB = "open";
        WDesktopPeer.ACTION_EDIT_VERB = "edit";
        WDesktopPeer.ACTION_PRINT_VERB = "print";
    }
}
